#include "paramSimul.h"
#include "objectBSSectorUe.h"
#include "evaluationConfigurerations.h"
#include <fstream>
#include <iostream>
using namespace std;


void Deploy_UMi_site(int sector_idx);
void Deploy_ue_in_layout();

void Deploy_bs_ue()
{
	if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
		{
			Deploy_UMi_site(bs_idx);
		}
	}
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		if (test_environment >=3)
		{
			ue[ue_idx].Drop_ue_in_site();
		}
		
	}
		
	Deploy_ue_in_layout();
	 
}


void Deploy_UMi_site(int bs_idx)
{
	
	double distance_bt_bs[3];
	bool a;
	
	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		do
		{
			bs[bs_idx].Deploy_UMi_site();
			bs_idx++;
			bs[bs_idx].Deploy_UMi_site();
			bs_idx++;
			bs[bs_idx].Deploy_UMi_site();

			distance_bt_bs[0] = pow(pow(bs[bs_idx].location.x - bs[bs_idx - 1].location.x, 2) + pow(bs[bs_idx].location.y - bs[bs_idx - 1].location.y, 2), 0.5);
			distance_bt_bs[1] = pow(pow(bs[bs_idx].location.x - bs[bs_idx - 2].location.x, 2) + pow(bs[bs_idx].location.y - bs[bs_idx - 2].location.y, 2), 0.5);
			distance_bt_bs[2] = pow(pow(bs[bs_idx - 2].location.x - bs[bs_idx - 1].location.x, 2) + pow(bs[bs_idx - 2].location.y - bs[bs_idx - 1].location.y, 2), 0.5);

			a = (distance_bt_bs[0] < micro_min_inter_site_distance) || (distance_bt_bs[1] < micro_min_inter_site_distance) || (distance_bt_bs[2] < micro_min_inter_site_distance);
			if (a == 1)
			{
				bs_idx = bs_idx - 2;
			}

		} while (a);
	}

	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		if ((bs_idx % 9) / 3 < 1)
		{
			bs[bs_idx].location.x -= inter_site_distance/ pow(3, 0.5) / pow(3, 0.5);

		}
		else if ((bs_idx % 9) / 3 < 2)
		{
			bs[bs_idx].location.x += inter_site_distance/ pow(3, 0.5)*pow(3, 0.5) / 6;
			bs[bs_idx].location.y += inter_site_distance/ pow(3, 0.5) / 2.;

		}
		else
		{
			bs[bs_idx].location.x += inter_site_distance / pow(3, 0.5)*pow(3, 0.5) / 6;
			bs[bs_idx].location.y -= inter_site_distance / pow(3, 0.5) / 2.;
		}
	}
	
}

void Deploy_ue_in_layout()
{

	
	if (test_environment < 3)
	{

		// bs_deployment
		// 6  7  8  9 10 11
		// 0  1  2  3  4  5 
		LOCATION bs_location[12];
		LOCATION ue_location;
		double distance_x, distance_y;

		for (int bs_idx = 0; bs_idx < 12; bs_idx++)
		{
			bs_location[bs_idx].x = 10. + (bs_idx%6) * 20.;
			if (bs_idx < 6)
			{
				bs_location[bs_idx].y = 15.;
			}
			else
			{
				bs_location[bs_idx].y = 35.;
			}
		}

		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			ue_location.x = Rand.u() * 120.;
			ue_location.y = Rand.u() * 50.;

			for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
			{
				distance_x = ue_location.x - bs_location[bs_idx].x;
				distance_y = ue_location.y - bs_location[bs_idx].y;

				channel[bs_idx][ue_idx].location.x = distance_x;
				channel[bs_idx][ue_idx].location.y = distance_y;

				channel[bs_idx][ue_idx]._2D_distance = pow((distance_x * distance_x + distance_y * distance_y), 0.5);
			}
		}

	}
	else if (test_environment == Dense_Urban_eMBB_C_Micro)
	{
		int  my_Micro_BS = (int)(num_bs * Rand.u());
		int  my_Macro_BS = (int)(19);

		int Macro_BS_num;
		int Macro_bs_idx = 0;

		double UE_x, UE_y;
		double BS_x, BS_y;
		double distance_x, distance_y;
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			UE_x = ue[ue_idx].location_in_site.x + bs[my_Micro_BS].location.x;
			UE_y = ue[ue_idx].location_in_site.y + bs[my_Micro_BS].location.y;

			for (int height = 0; height < 5; height++)
			{
				int vert = 2 - height;
				int num_horiz = 5 - abs(vert);
				for (int horiz = 0; horiz < num_horiz; horiz++)
				{

					Macro_BS_num = wrap[my_Macro_BS][Macro_bs_idx];

					channel[Macro_BS_num][ue_idx].location.x = UE_x - (horiz - 2. + 0.5 * abs(vert)) * inter_site_distance;
					channel[Macro_BS_num][ue_idx].location.y = UE_y - vert * sqrt(3.0) * inter_site_distance / 2.;


					for (int micro_bs_idx = 0; micro_bs_idx < 9; micro_bs_idx++)
					{
						BS_x = (horiz - 2. + 0.5 * abs(vert)) * inter_site_distance + bs[micro_bs_idx + 9 * Macro_BS_num].location.x;
						BS_y = vert * sqrt(3.0) * inter_site_distance / 2. + bs[micro_bs_idx + 9 * Macro_BS_num].location.y;

						distance_x = UE_x - BS_x;
						distance_y = UE_y - BS_y;

						channel[micro_bs_idx + 9 * Macro_BS_num][ue_idx]._2D_distance = sqrt(distance_x * distance_x + distance_y * distance_y);
					}
					Macro_bs_idx++;
				}
			}
		}
	}
	else
	{
		int BS_num;
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			ue[ue_idx].site_idx = ue_idx / (num_user_per_sector*num_TRxP_per_site);// (int)(19. * Rand.u());// 


			//cout << "ue_idx : " << ue_idx << endl;
			//cout << "ue[ue_idx].site_idx : " << ue[ue_idx].site_idx << endl;
			//getchar();
			for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
			{
				BS_num = wrap[ue[ue_idx].site_idx][bs_idx];

				channel[BS_num][ue_idx].location.x = ue[ue_idx].location_in_site.x - bs_location[bs_idx].x;
				channel[BS_num][ue_idx].location.y = ue[ue_idx].location_in_site.y - bs_location[bs_idx].y;

				channel[BS_num][ue_idx]._2D_distance = sqrt(channel[BS_num][ue_idx].location.x*channel[BS_num][ue_idx].location.x + channel[BS_num][ue_idx].location.y*channel[BS_num][ue_idx].location.y);

			}
		}
	}

}