#include "paramSimul.h"
#include "ue.h"
#include "objectBSSectorUe.h"
#include "const.h"
#include <vector> 
#include <algorithm> 
#include "paramStatistics.h"

#include <Windows.h>

using namespace std;


void Collect_Couplingloss()
{
	for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
	{
		_couplingloss[drop_idx*num_ue + ue_idx] = ue[ue_idx].couplingloss_dB;
		_geometry[drop_idx*num_ue + ue_idx] = ue[ue_idx].geometry;
	}	
	
	for (int bs_idx = 0; bs_idx < num_bs; bs_idx++)
	{
		for (int ue_idx = 0; ue_idx < num_ue; ue_idx++)
		{
			_2Ddistance[drop_idx*num_ue*num_bs + num_ue *bs_idx + ue_idx] = channel[bs_idx][ue_idx]._2D_distance;
		}
	}
}


void Get_Couplingloss_CDF()
{
	vector <double> _2Ddistance_cdf;
	vector <double> _couplingloss_cdf;
	vector <double> _geometry_cdf;


	_2Ddistance_cdf.clear();
	_couplingloss_cdf.clear();
	_geometry_cdf.clear();

	
	sort(_2Ddistance, _2Ddistance + num_ue * num_drops*num_bs);
	sort(_couplingloss, _couplingloss + num_ue*num_drops);
	sort(_geometry, _geometry + num_ue * num_drops);
	
	_2Ddistance_cdf.push_back(_2Ddistance[0]);
	_couplingloss_cdf.push_back(_couplingloss[0]);
	_geometry_cdf.push_back(_geometry[0]);
	
	for (int percentile = 1; percentile < 101; percentile++)
	{
		int idx = (int)((num_ue*num_drops - 1)*percentile*0.01);
		_couplingloss_cdf.push_back(_couplingloss[idx]);
		_geometry_cdf.push_back(_geometry[idx]);

		int d_idx = (int)((num_ue*num_drops*num_bs - 1)*percentile*0.01);
		_2Ddistance_cdf.push_back(_2Ddistance[d_idx]);
	}



	ofstream Distance;
	ofstream  Couplingloss;
	ofstream  Geometry;
	char file_name[70];
	char file_name1[70];
	char file_name2[70];

	strcpy_s(file_name, sizeof(file_name), "Couplingloss");
	strcpy_s(file_name1, sizeof(file_name1), "Geometry");
	strcpy_s(file_name2, sizeof(file_name2), ".xls"); 
	//strcat_s(file_name, sizeof(file_name), "/NLOS.xls");

	
	if (pathloss_model == InH_A)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_B_Geometry_A.xls");
		}
		else 
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_C_Geometry_A.xls");

		}


	}
	else if (pathloss_model == InH_B)
	{
		if (test_environment == InH_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_A_Geometry_B.xls");
			

		}
		else if (test_environment == InH_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_B_Geometry_B.xls");

		}
		else
		{
			strcat_s(file_name, sizeof(file_name), "/InH_eMBB_C_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/InH_eMBB_C_Geometry_B.xls");

		}
	}
	else if (pathloss_model == UMa_A || pathloss_model == UMi_A)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_B_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Macro_Geometry_A.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Micro_Geometry_A.xls");

		}
	}
	else if (pathloss_model == UMa_B || pathloss_model== UMi_B)
	{
		if (test_environment == Dense_Urban_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_A_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_B_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Macro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Macro_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Macro_Geometry_B.xls");

		}
		else if (test_environment == Dense_Urban_eMBB_C_Micro)
		{
			strcat_s(file_name, sizeof(file_name), "/Dense_Urban_eMBB_C_Micro_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Dense_Urban_eMBB_C_Micro_Geometry_B.xls");

		}
	}
	else if (pathloss_model == RMa_A)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_A_Geometry_A.xls");

		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_B_Geometry_A.xls");

		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Couplingloss_A.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_C_Geometry_A.xls");

		}
	}
	else if (pathloss_model == RMa_B)
	{
		if (test_environment == Rural_eMBB_A)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_A_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_A_Geometry_B.xls");
		}
		else if (test_environment == Rural_eMBB_B)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_B_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_B_Geometry_B.xls");
		}
		else if (test_environment == Rural_eMBB_C)
		{
			strcat_s(file_name, sizeof(file_name), "/Rural_eMBB_C_Couplingloss_B.xls");
			strcat_s(file_name1, sizeof(file_name1), "/Rural_eMBB_C_Geometry_B.xls");
		}
	}

	else
	{
		cout << "check file name" << endl;
		getchar();
	}

	Couplingloss.open(file_name, ios::out);
	Geometry.open(file_name1, ios::out);
	Distance.open(file_name2, ios::out);

	Couplingloss <<"# " << "\t" << "# Couplingloss "  << endl;
	Geometry << "# " << "\t" << "# Geometry " << endl;

	for (int x_idx = 0; x_idx < 101; x_idx++)
	{
		Couplingloss << _couplingloss_cdf[x_idx] << "\t" <<endl;
		Geometry << _geometry_cdf[x_idx] << "\t"  << endl;
		Distance<< _2Ddistance_cdf[x_idx] << "\t" << endl;

	}
	Distance.close();
	Couplingloss.close();
	Geometry.close();
}



